<?php
namespace Teknisa\Model\Qualidade\Repositories;


class Tiporesu extends \Doctrine\ORM\EntityRepository {
    
    public  function retornaFaixaCriteriosQuestaoRepository($arrayNrquestavalia){
    //Retorna as faixas de criterios que pertencem a questao informada
    $sqlFaixaCrit = <<<SQL
    SELECT TIPORESU.CDTIPORESU, 
                            FAIXACRITRESULT.IDFAIXACRIRESUL, FAIXACRITRESULT.VRINIFAIXARESUL, FAIXACRITRESULT.VRFINFAIXARESUL,
                            CRITERIORESULT.NRCRITERIORESUL
                       FROM CRITERIORESULT
                      INNER JOIN FAIXACRITRESULT
                         ON CRITERIORESULT.NRCRITERIORESUL   = FAIXACRITRESULT.NRCRITERIORESUL
                      INNER JOIN QUESTAVALIACAO
                         ON CRITERIORESULT.NRCRITERIORESUL   = QUESTAVALIACAO.NRCRITERIORESUL
                      INNER JOIN TIPORESU
                         ON TIPORESU.CDTIPORESU              = FAIXACRITRESULT.CDTIPORESU
                      WHERE QUESTAVALIACAO.NRAVALIACAO     = :P_NRAVALIACAO
                        AND QUESTAVALIACAO.NRQUESTAVALIA   = :P_NRQUESTAVALIA
SQL;
    return $this->getEntityManager()->createQuery($query)->execute($arrayNrquestavalia);
    }
    
    public function retornaFaixaCriteriosRepository($arrayNravaliacao){
        // Retorna as faixas de criterios que pertencem a avaliacao informada
        // leonardocarvalho - 10/12/2014 - Adicionado parâmentro de NRORG
        $avaliacaoGeral =  'Teknisa\Model\Avaliacao\Entities\Avaliacaogeral';
        $tipoResu =  'Teknisa\Model\Qualidade\Entities\Tiporesu';
        $criterioResult =  'Teknisa\Model\Avaliacao\Entities\Criterioresult';
        $faixaCritresult =  'Teknisa\Model\Avaliacao\Entities\Faixacritresult';
        
$query = <<<SQL
SELECT DISTINCT t.cdtiporesu, f.idfaixacriresul, f.vrinifaixaresul, f.vrfinfaixaresul, c.nrcriterioresul
FROM $criterioResult c
LEFT JOIN $avaliacaoGeral av
    WITH av.nrcriterioresul = c.nrcriterioresul
    AND av.nrorg = c.nrorg
LEFT JOIN $faixaCritresult f 
    WITH f.nrcriterioresul = c.nrcriterioresul
    AND (f.nrorg = av.nrorg or f.nrorg = :p_nrorg_padrao)
LEFT JOIN $tipoResu t
    WITH t.cdtiporesu = f.cdtiporesu
    AND t.nrorg = av.nrorg
WHERE c.nrorg = :p_nrorg 
AND av.nravaliacao = :p_nravaliacao
SQL;
        $result = $this->getEntityManager()->createQuery($query)->execute($arrayNravaliacao);
        	return $result;  
    }

    
}